/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/
#include <ncbi.h>
#include <blast/blast.h>

char *BlastErrStr(errnum)
	BLAST_Error	errnum;
{
	switch (errnum) {
	case BLAST_ERR_NONE:
		return "no error";
	case BLAST_ERR_INVAL:
		return "invalid parameter";
	case BLAST_ERR_DOMAIN:
		return "invalid domain for a parameter";
	case BLAST_ERR_RANGE:
		return "invalid range for parameters";
	case BLAST_ERR_MEM:
		return "out of memory";
	case BLAST_ERR_EXTENT:
		return "extent of request is too great";
	case BLAST_ERR_POP:
		return "no saved state to pop";
	case BLAST_ERR_FFORMAT:
		return "file format error";
	case BLAST_ERR_CONV:
		return "conversion error";
	case BLAST_ERR_NF:
		return "object not found";
	case BLAST_ERR_INIT:
		return "object not initialized";
	case BLAST_ERR_ALPHATYPE:
		return "incorrect type of alphabet";
	case BLAST_ERR_ALPHASIZE:
		return "too many letters in alphabet";
	case BLAST_ERR_ALPHAVAL:
		return "letter not in alphabet";
	case BLAST_ERR_ALPHACONFLICT:
		return "conflicting alphabets";
	case BLAST_ERR_LETTER:
		return "invalid letter value";
	case BLAST_ERR_SENTINEL:
		return "invalid sentinel";
	case BLAST_ERR_RESFREQ:
		return "invalid residue frequencies";
	case BLAST_ERR_SCORE_RANGE:
		return "range in single-letter substitution scores is too wide";
	case BLAST_ERR_SCORE_DOMAIN:
		return "single-letter substitution score limit is too low or too high";
	case BLAST_ERR_SCORE_AVG:
		return "average or expected score is non-negative or nearly zero";
	case BLAST_ERR_SCOREBLK_TYPE:
		return "improper BlastScoreBlkType";
	case BLAST_ERR_DFA:
		return "error in DFA library";
	case BLAST_ERR_WORDSIZE:
		return "invalid wordsize";
	case BLAST_ERR_CONTEXT:
		return "too many contexts or invalid context";
	case BLAST_ERR_WFSTATE:
		return "invalid WordFinder state";
	case BLAST_ERR_ENCODING:
		return "invalid alphabet encoding requested";
	case BLAST_ERR_QUERYLEN:
		return "unsupported query sequence length";
	case BLAST_ERR_SUBJECTLEN:
		return "unsupported subject sequence length";
	case BLAST_ERR_APPLICATION:
		return "application error";
	case BLAST_ERR_UNDEF:
	default:
		return "undefined";
	}
	/*NOTREACHED*/
}
