/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/
#ifndef __BLAST_NEIGHBOR__
#define __BLAST_NEIGHBOR__
#ifdef __cplusplus
extern "C" {
#endif

/****  Typedefs  ****/

/****  Prototypes  ****/

int	BlastWFContextNeighborhoodAdd PROTO((BLAST_WFContextPtr wfcp, size_t start, size_t len, BLAST_Score T, int process));

int BlastStdWordFltr PROTO((BLAST_FilterPtr, size_t, BLAST_LetterPtr, int, BLAST_ScoreBlkPtr, BLAST_Score, int));

int BlastSelfScoreWordFltr PROTO((BLAST_FilterPtr, size_t, BLAST_LetterPtr, int, BLAST_ScoreBlkPtr, BLAST_Score, int));

int BlastNeighborhoodWordFltr PROTO((BLAST_FilterPtr, size_t, BLAST_LetterPtr, int, BLAST_ScoreBlkPtr, BLAST_Score, int));

int BlastNWGenFoo PROTO((int (*)(), Nlm_VoidPtr, size_t, BLAST_LetterPtr, int, BLAST_ScoreBlkPtr, unsigned PNTR, int));

/****  Function names  ****/

#ifdef __cplusplus
}
#endif
#endif /* !__BLAST_NEIGHBOR__ */
