/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/
#ifndef __BLAST_SORT__
#define __BLAST_SORT__
#ifdef __cplusplus
extern "C" {
#endif

typedef enum blast_hlcmp { /* potential HitList comparison criteria */
	BLAST_HLCMP_PVALUE = 1,
	BLAST_HLCMP_EVALUE,
	BLAST_HLCMP_SCORE,
	BLAST_HLCMP_COUNT,
	BLAST_HLCMP_LENGTH,
	BLAST_HLCMP_HIGHSCORE,
	BLAST_HLCMP_TOTALSCORE,
	BLAST_HLCMP_MAX
	} BLAST_HLCmp, PNTR BLAST_HLCmpPtr;

typedef enum blast_hspcmp { /* potential HSP comparison criteria */
	BLAST_HSPCMP_PVALUE = 1,
	BLAST_HSPCMP_EVALUE,
	BLAST_HSPCMP_FRAME,
	BLAST_HSPCMP_SCORE,
	BLAST_HSPCMP_NORMSCORE,
	BLAST_HSPCMP_N,
	BLAST_HSPCMP_LENGTH,
	BLAST_HSPCMP_OFFSET,
	BLAST_HSPCMP_MAX
	} BLAST_HSPCmp, PNTR BLAST_HSPCmpPtr;


ValNodePtr LIBCALL BlastHitListCmpCriterionAdd PROTO((ValNodePtr PNTR, BLAST_HLCmp));
void LIBCALL BlastHitListSort PROTO((BLAST_HitListPtr PNTR, ValNodePtr));
int LIBCALL BlastHitListCmpStd PROTO((BLAST_HitListPtr, BLAST_HitListPtr, ValNodePtr));
int LIBCALL BlastHitListPtrCmpStd PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR, ValNodePtr));
int LIBCALL BlastHitListCmpByPvalue PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));
int LIBCALL BlastHitListCmpByEvalue PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));
int LIBCALL BlastHitListCmpByScore PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));
int LIBCALL BlastHitListCmpByLength PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));
int LIBCALL BlastHitListCmpByCount PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));
int LIBCALL BlastHitListCmpByHighScore PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));
int LIBCALL BlastHitListCmpByTotalScore PROTO((BLAST_HitListPtr PNTR, BLAST_HitListPtr PNTR));

ValNodePtr LIBCALL BlastHSPCmpCriterionAdd PROTO((ValNodePtr PNTR, BLAST_HSPCmp));
void LIBCALL BlastHSPSort PROTO((BLAST_HSPPtr PNTR, ValNodePtr));
int LIBCALL BlastHSPCmpStd PROTO((BLAST_HSPPtr, BLAST_HSPPtr, ValNodePtr));
int LIBCALL BlastHSPPtrCmpStd PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR, ValNodePtr));
int LIBCALL BlastHSPCmpByPvalue PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByEvalue PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByFrame PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByScore PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByNormScore PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByLength PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByOffset PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));
int LIBCALL BlastHSPCmpByN PROTO((BLAST_HSPPtr PNTR, BLAST_HSPPtr PNTR));

#ifdef __cplusplus
}
#endif
#endif /* !__BLAST_SORT__ */
