/* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================*/
#include <ncbi.h>
#include <blast/blast.h>

BLAST_VScorePoolPtr
BlastVScorePoolNew(cnt)
	size_t	cnt;
{
	BLAST_VScorePoolPtr	vspp;

	vspp = (BLAST_VScorePoolPtr) PoolNew(cnt, sizeof(BLAST_VScore), offsetof(BLAST_VScore,next), NULL);
	return vspp;
}

void LIBCALL
BlastVScorePoolDestruct(vspp)
	BLAST_VScorePoolPtr	vspp;
{
	PoolDestruct((PoolBlkPtr)vspp);
}


BLAST_VScorePtr
BlastVScorePoolGet(vspp, vnp)
	BLAST_VScorePoolPtr	vspp;
	ValNodePtr	vnp;
{
	register BLAST_VScorePtr	vsp;

	vsp = (BLAST_VScorePtr) PoolGet((PoolBlkPtr)vspp);
	if (vsp != NULL)
		*vsp = *(BLAST_VScorePtr)vnp;
	return vsp;
}

void
BlastVScorePoolPut(vspp, vsp)
	BLAST_VScorePoolPtr	vspp;
	BLAST_VScorePtr	vsp;
{
	PoolPut((PoolBlkPtr)vspp, vsp);
}

void
VScorePoolPutLink(vspp, vsp)
	BLAST_VScorePoolPtr	vspp;
	BLAST_VScorePtr	vsp;
{
	PoolPutLink((PoolBlkPtr)vspp, vsp);
}

BLAST_VScorePtr
BlastVScoreUserTypeFind(vsp, choice)
	register BLAST_VScorePtr	vsp;
	register int		choice;
{
	for (; vsp != NULL; vsp = vsp->next)
		if (vsp->choice == choice)
			return vsp;

	return NULL;
}
